#include<iostream>
#include<signal.h>

#include "BootStrapServer.h"
#include "util.h"

void SetupSignalHandler();
void SignalHandler(int sig);

CBootStrapServer *srvObj = NULL;
bool bForeground = false;
bool bRun = true;
const char* pid_file="pid.txt";
const char* log_file="log1.txt";


int main(int argc, char* argv[]){

	srvObj = new CBootStrapServer("server_config.txt");
        //foreground?
        if(argv[1]){
                if(strcmp(argv[1],"-f")==0){
                        std::cout<<"Running foreground\n";
                        bForeground = true;
                }
        }


	SetupSignalHandler();

        if( !bForeground )
        {
		unlink(log_file);
                std::cout<<"Creating Child\n";
                int ret = RunAsDaemon(log_file);
                if (ret < 0)
                {
                        std::cerr << "Could not background.  Exiting." ;
                        exit(-2);
                }
                else if( ret == 0 ) //parent exits..
                {
                        return 0;
                }

                // child continues
                if( write_pid(pid_file) == -1 ){
                        std::cout<<"Can't write pid file\n";
                }

        }


	int iRet = srvObj->Start();
	
	std::cout<<"Exiting.."<<std::endl;
	unlink(pid_file);

return 0;
}

/*Signal handling*/
void SetupSignalHandler(){

	(void) signal(SIGINT,SignalHandler);
	(void) signal(SIGTERM,SignalHandler);
	(void) signal(SIGSEGV,SignalHandler);
	(void) signal(SIGILL,SignalHandler);
	(void) signal(SIGABRT,SignalHandler);
}


void SignalHandler(int sig){

	printf("in signal handler\n");
	delete srvObj;
	unlink(pid_file);
	//exit(sig);
}

