#ifndef BOOTSTRAP_CLIENT_H
#define BOOTSTRAP_CLIENT_H


#include<string>
#include<vector>

class CFileTransfer;
class EventMessage;

/**
* A class for communicating with Bootstrap server.
*/
class CBootStrapClient{

public:
	/**
	* Constructor of the class.
	*/
	CBootStrapClient();

	/**
	* Destructor of the class.
	*/
	virtual ~CBootStrapClient();

	/**
	* Connects with the server for getting bootstraping information.
	* Waits for notification from the CFileTrnafer.
	*/
	int Download(uint32_t server_ip, uint16_t server_port, const std::string& sDownloadDir);
	EventMessage* GetEventMessage()const{return m_pEventMsg;}

private:
	int Connect();
	int InitSocketPair();
	
	/**
	* When CFileTransfer notifies, the notification is handled by this function.
	*/
	int HandleNotification(int);

private:
	uint32_t	m_uServerIP;
	uint16_t	m_uServerPort;
	std::string	m_sDownloadDir;
	int		m_iSockPairFd[2];
	typedef std::vector<CFileTransfer*> FileTransfer;
	FileTransfer m_filetrans;
	EventMessage*	m_pEventMsg;

};
#endif//
