#include<stdio.h>
#include<signal.h>
#include<string.h>
#include<iostream>


#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>


#include "util.h"
#include "multicast.h"
#include "EventMessage.h"

extern "C"{
#include "pgm/pgm_interface.h"
}

int CMulticast::m_iFd = -1;

CMulticast::CMulticast(const std::string& sInterface, uint32_t ip, uint16_t port):
	m_bInit(false)
{


	if(!init_pgm()){
		m_bInit = false;
		return;
	}

	std::string sInterfaceIP = sInterface+";"+GetDotFormatIP(ip);

	if(!create_send_transport(sInterfaceIP.c_str(),port, 0, false)){
		std::cout<<"Failed to create sender transport\n";
		m_bInit = false;
		return;
	}

	if(!create_recv_transport(sInterfaceIP.c_str(),port, 0, false)){
		std::cout<<"Failed to create receiver transport\n";
		m_bInit = false;
		return;
	}

	if(start_receiver_thread()!=0){
		std::cout<<"Failed to create receiver thread\n";
		m_bInit = false;
		return;
	}

	set_filetransfer_callback(&FileReceivedCallback);
	m_bInit = true;
}

CMulticast::~CMulticast(){

	if(m_bInit)
		close_pgm();

	m_bInit = false;
	std::cout<<"Closed PGM"<<std::endl;
}

int CMulticast::SendFile(const std::string& sFileName, const std::string& sFileLoc){

	if(m_bInit)
		return send_file(sFileName.c_str(), sFileName.size(), sFileLoc.c_str(), sFileLoc.size(), GetFileSize(sFileLoc));
	else
		return -1;
return 0;
}

int CMulticast::SendPacket(const std::string& s){

	if(m_bInit)
		return send_packet(s.c_str(), s.size());
	else
		return -1;
return 0;
}

/*Notify with EventMessage*/
void CMulticast::FileReceivedCallback(fileinfo* f){

	std::cout<<"In FileReceived Callback\n";
	bool bSuccess(true);

        EventMessage msg;
        if(bSuccess){
                msg.SetStatus(EVT_SUCCESS);
                //msg.SetReasonCode(FILEFINISH);
        }
        else{
                msg.SetStatus(EVT_ERROR);
                //msg.SetReasonCode(FILEERR);
        }

        msg.SetFileSize(f->m_iFileSize);
        msg.SetFileName(std::string(f->m_szFileName, f->m_iFileNameLen));
        msg.SetFilePath(std::string(f->m_szFileName, f->m_iFileNameLen));
        msg.SetFileType(FILE_GOSSIP);
        msg.SetRelatedModule(MODULE_MULTICAST);

        std::string sBuf;
        msg.serialize(sBuf);

        int iStatus = ::send(GetSocketPairFd(), sBuf.c_str(), sBuf.size(), 0);
        if(iStatus<0){
                perror("error in notify complete..");
        }

}

