#ifndef _PGM_H
#define _PGM_H

struct fileinfo;
typedef struct fileinfo file_info;


/**
* An interface class for communicating with OpenPGM library.
*/
class CMulticast{

public:
	/**
	* Constructor of the class. Takes interface name, multicast IP address and port as its argument.
	*/
	CMulticast(const std::string& sInterface, uint32_t ip, uint16_t port);

	/**
	* Destructor of the class.
	*/
	virtual ~CMulticast();

	/**
	* Sends the multicast file in the network.
	*/
	int SendFile(const std::string& sFileName, const std::string& sFileLoc);
	int SendPacket(const std::string& s);

	/**
	* The network thread of the multicast library notifies about any downloaded file.
	*/
	static void FileReceivedCallback(fileinfo* f);

	static void SetSocketPair(int iFd){m_iFd = iFd;}
	static int GetSocketPairFd(){return m_iFd;}


private:
	bool m_bInit;
	static int m_iFd;
};

#endif//
