#include "EventMessage.h"

/*
Author: Md Sazzadur Rahman:
rahmanm@cs.ucr.edu
*/

EventMessage::EventMessage():
	m_iStatus(EVT_ERROR),
	m_iReasonCode(0),
	m_iReasonStringLen(0),
	m_sReasonString(),
	m_8FileType(0),
	m_iFileSize(0),
	m_iFileNameLen(0),
	m_sFileName(),
	m_iFilePathLen(0),
	m_sFilePath(),
	m_iSearchID(-1),
	m_8RelatedModule(MODULE_UNKNOWN){
}

EventMessage::~EventMessage(){
}


void EventMessage::serialize(std::string& sBuf) const {

	//sBuf.erase();
	Serialize32(m_iStatus, sBuf);
	Serialize32(m_iReasonCode, sBuf);
	Serialize32(m_iReasonStringLen, sBuf);
        SerializeCString((const char*)m_sReasonString.c_str(), m_iReasonStringLen, sBuf);
	Serialize8(m_8FileType, sBuf);
	Serialize32(m_iFileSize, sBuf);
	Serialize32(m_iFileNameLen, sBuf);
        SerializeCString((const char*)m_sFileName.c_str(), m_iFileNameLen, sBuf);
	Serialize32(m_iFilePathLen, sBuf);
        SerializeCString((const char*)m_sFilePath.c_str(), m_iFilePathLen, sBuf);
	Serialize32(m_iSearchID, sBuf);
	Serialize8(m_8RelatedModule, sBuf);
}

int EventMessage::deserialize(const std::string& sBuf){

#define MAXLEN 3000
	char szBuf[MAXLEN]={0};

        int iOffset = 0;

        Deserialize32((u_int32_t&)m_iStatus, sBuf, iOffset);
        Deserialize32((u_int32_t&)m_iReasonCode, sBuf, iOffset);
        Deserialize32((u_int32_t&)m_iReasonStringLen, sBuf, iOffset);

	bzero(szBuf,MAXLEN);
        DeserializeCString(szBuf, m_iReasonStringLen, sBuf, iOffset);
	if(m_iReasonStringLen<=MAXLEN){
		m_sReasonString = std::string(szBuf, m_iReasonStringLen);
	}

        Deserialize8(m_8FileType, sBuf, iOffset);
        Deserialize32((u_int32_t&)m_iFileSize, sBuf, iOffset);
        Deserialize32((u_int32_t&)m_iFileNameLen, sBuf, iOffset);

	bzero(szBuf,MAXLEN);
        DeserializeCString(szBuf, m_iFileNameLen, sBuf, iOffset);
	if(m_iFileNameLen<=MAXLEN){
		m_sFileName = std::string(szBuf, m_iFileNameLen);
	}

        Deserialize32((u_int32_t&)m_iFilePathLen, sBuf, iOffset);

	bzero(szBuf,MAXLEN);
        DeserializeCString(szBuf, m_iFilePathLen, sBuf, iOffset);
	if(m_iFilePathLen<=MAXLEN)
		m_sFilePath = std::string(szBuf, m_iFilePathLen);

        Deserialize32((u_int32_t&)m_iSearchID, sBuf, iOffset);

        Deserialize8(m_8RelatedModule, sBuf, iOffset);

return iOffset;
}

