#ifndef UTIL_H
#define UTIL_H

#include<vector>


/** \file util.h
* Utility functions.
*/

typedef std::pair<uint32_t, uint16_t> AddressPortPair;

/**
* Gets the file size in bytes of a given file.
*/
int GetFileSize(const std::string& sFile);

/**
* Gets the dot formatted IP address as a string from int IP.
*/
std::string GetDotFormatIP(uint32_t ip);


/**
* Set the socket for reusing.
*/
void reuse(int fd);

/**
* Set the socket for as non blocking.
*/
void nonblock(int fd);

/**
* Disables nagle's algorithm.
*/
void nodelay(int fd);
void ByteOrderTesting();

/**
* Makes the current process as a daemon.
*/
int RunAsDaemon(const char* stdoutname);
int write_pid(const char * sFileName);

/**
* Gets the ip and port from a socket.
* Useful for debugging.
*/
AddressPortPair GetSockName(uint32_t sock);

/**
* Special string tokenizer; not generic.
*/
int StringTokenizer(const std::string sToParse, const char* cToken, std::vector<std::string>& v);






#endif//UTIL_H
